Subject: Re: [PATCH/RFC] builtin-checkout: suggest creating local branch when appropriate to do so

From: Uri Okrent <[email-masked]>
Date: Sun, 25 Oct 2009 10:44:27 -0700

Junio C Hamano wrote:
  > When you do not have local "frotz" branch, and do have cloned/fetched from
> the origin that has "frotz" branch, I am actually Ok with this
> 
>     $ git checkout frotz [--]
> 
> to do an equivalent of:
> 
>     $ git checkout -t -b frotz origin/frotz
> 
> I do not have problem with this _particular_ DWIMmery.  It will not break
> people's expectations, other than "asking to check out non-existing ref
> should fail".  That expectation might be logical, but I do not think it is
> useful.

FWIW most of the people we train (and we do spend time explaining the
distinction between origin/foo and foo) still find it annoying to have
to create local branches that track branches from the cloned repo.  I
think this probably has something to do with the fact that master is
automatically checked out when you clone--people expect other upstream
branches to just 'exist' locally in a similar fashion.

I think the above suggestion is simple enough and would provide the most
bang-for-your-buck in terms of usability.
-- 
    Uri

Please consider the environment before printing this message.
http://www.panda.org/how_you_can_help/